#ifndef AMP_PARAMS_H
#define AMP_PARAMS_H

#include <glib.h>

extern char *_amp_model_table[];
extern char *_cab_model_table[];
extern char *_vol_type_table[];
extern char *_reverb_type_table[];
extern char *_effect_name_table[];
extern char *_compression_ratio_table[];
extern int _effect_translation_table[];

typedef struct
{
  guint8 amp_type;  /* enum */
  guint8 cab_type;
  guint8 air;
  guint8 drive;
  guint8 drive2;
  guint8 bass;
  guint8 mid;
  guint8 treble;
  guint8 presence;
  guint8 channel_volume; 

  gboolean drive_boost_on;
  gboolean distortion_on;
  gboolean presence_on;
  gboolean delay_on;
  gboolean rotary_on;
  gboolean reverb_on;
  gboolean noise_gate_on;
  gboolean bright_on;

  guint8 gate_threshold;
  guint8 gate_decay;

  guint8 wah_current;
  guint8 wah_bottom;
  guint8 wah_top;

  guint8 vol_type;     /* change to enum */ 
  guint8 vol_current; 
  guint8 vol_minimum; 

  guint8 effect;
  guint8 effect_params[5];

  guint8 rotary_depth;
  gboolean rotary_speed;
  guint8 rotary_speed_min;
  guint8 rotary_speed_max;

  guint8 tremolo_depth;
  guint8 tremolo_speed;

  guint8 chorus_predelay_unscaled;
  guint8 chorus_predelay;
  guint8 chorus_speed;
  guint8 chorus_depth;
  guint8 chorus_feedback;

  guint8 reverb_type;
  guint8 reverb_decay;
  guint8 reverb_tone;
  guint8 reverb_diffuse;
  guint8 reverb_density;
  guint8 reverb_level;

  guint8 compression_ratio;
  guint8 swell_amplitude;

  guint delay_unscaled;
  guint delay_time;
  guint8 delay_coarse;
  guint8 delay_fine;
  guint8 delay_feedback;
  guint8 delay_level;

} amp_params_t;

#endif
