#ifndef LIBFILE_H
#define LIBFILE_H

#include <glib.h>
#include <time.h>
#include "amp_params.h"

typedef struct 
{
  char form[5];        /* "FORM" */
  int size;            /* file size - 8 */
  char sslb[5];        /* "SSLB" */
} lf_form_block_t;

typedef struct
{
  char lhdr[5];        /* "LHDR" */
  int size;
  char *data;
} lf_lhdr_block_t;

typedef struct
{
  char wseq[5];        /* "WSEQ" */
  int size;
  char *data;
} lf_wseq_block_t;

typedef struct
{
  char lent[5];
  int size;

  gint8 title_size;
  char title[256];

  amp_params_t params;

  time_t date;

  gint8 location_size;
  char location[256];

  gint8 comment_size;
  char comment[256];

  /* stuff I don't know about yet */
  char pad1[13];
  char pad2[11];
  char pad3;
  char pad4;
  char pad5[15];
  char pad6[5];
  char pad7[6];

} lf_lent_block_t;

typedef struct
{
  gboolean is_big_endian;

  lf_form_block_t form;
  lf_lhdr_block_t lhdr;
  lf_wseq_block_t wseq;
  lf_lent_block_t lent;

} libfile_t;

libfile_t *libfile_new(char *filename);
void libfile_print(libfile_t *file);
void libfile_destroy(libfile_t *libfile);

#endif /* LIBFILE_H */
