#ifndef MIDI_XFER_H
#define MIDI_XFER_H

#include "amp_params.h"

typedef struct
{
    int fd;
} midi_context_t;

typedef enum
{
    CT_AMP_MODEL,
    CT_DRIVE,
    CT_DRIVE_2,
    CT_BASS, 
    CT_MID, 
    CT_TREBLE, 
    CT_BRIGHT, 
    CT_PRESENCE, 
    CT_CHANNEL_VOL, 
    CT_NOISE_GATE,
    CT_GATE_THRESH,
    CT_GATE_DECAY,
    CT_EFFECT_SELECT,
    CT_EFFECT_TWEAK,
    CT_DISTORTION,
    CT_BOOST,
    CT_EQ,
    CT_DELAY,
    CT_DELAY_TIME,
    CT_DELAY_FINE,
    CT_DELAY_REPEATS,
    CT_DELAY_LEVEL,
    CT_REVERB,
    CT_REVERB_TYPE,
    CT_REVERB_DECAY,
    CT_REVERB_TONE,
    CT_REVERB_DIFFUSE,
    CT_REVERB_DENSITY,
    CT_REVERB_LEVEL,
    CT_COMPRESSION,
    CT_WAH,
    CT_WAH_LEVEL,
    CT_WAH_BOTTOM,
    CT_WAH_TOP,
    CT_VOLUME_LOCATION,
    CT_VOLUME_MIN,
    CT_VOLUME_LEVEL,
    CT_SWELL,
    CT_SWELL_RAMP,
    CT_TAP,
    CT_CHORUS,
    CT_CHORUS_SPEED,
    CT_CHORUS_DEPTH,
    CT_CHORUS_FEEDBACK,
    CT_CHORUS_PREDELAY,
    CT_ROTARY_SPEED,
    CT_ROTARY_SPEED_MAX,
    CT_ROTARY_SPEED_MIN,
    CT_TREM_SPEED,
    CT_TREM_DEPTH,
    CT_CAB_MODEL,
    CT_AIR
} control_type_t;

char *midi_find_device();
midi_context_t *midi_open(char *device);
void midi_send_params(midi_context_t *m, amp_params_t *params);
void midi_set_param(midi_context_t *m, control_type_t control, int value);
void midi_close(midi_context_t *m);


#endif
